package czlib

import (
	"bytes"
	"io"
	"testing"
)

func TestInflateDefault(t *testing.T) {
	defaultInput := []byte{120, 156, 203, 72, 205, 201, 201, 215, 81,
		40, 207, 47, 202, 73, 225, 2, 0, 33, 231, 4, 147}
	b := bytes.NewReader(defaultInput)
	r, err := NewReader(b)
	checkFatalError(t, err)

	buf := &bytes.Buffer{}
	_, err = io.Copy(buf, r)
	checkFatalError(t, err)
	err = r.Close()
	checkFatalError(t, err)

	if buf.String() != "hello, world\n" {
		t.Errorf("output differs from expected")
	}
}

func TestInflateBest(t *testing.T) {
	bestInput := []byte{120, 218, 203, 72, 205, 201, 201, 215, 81,
		40, 207, 47, 202, 73, 225, 2, 0, 33, 231, 4, 147}
	b := bytes.NewReader(bestInput)
	r, err := NewReader(b)
	checkFatalError(t, err)

	buf := &bytes.Buffer{}
	_, err = io.Copy(buf, r)
	checkFatalError(t, err)
	err = r.Close()
	checkFatalError(t, err)

	if buf.String() != "hello, world\n" {
		t.Errorf("output differs from expected")
	}
}
