#include <zlib.h>
#include <stdlib.h>

int zstream_deflate_init(z_stream *strm, int level, int method, int windowBits, int memLevel, int strategy) {
  strm->zalloc = Z_NULL;
  strm->zfree  = Z_NULL;
  strm->opaque = Z_NULL;
  return deflateInit2(strm, level, method, windowBits, memLevel, strategy);
}

int zstream_deflate(z_stream *strm, int flush) {
  return deflate(strm, flush);
}

int zstream_deflate_end(z_stream *strm) {
  return deflateEnd(strm);
}

void zstream_set_in_buf(z_stream *strm, void *buf, unsigned int len) {
  strm->next_in  = (Bytef*)buf;
  strm->avail_in = len;
}

void zstream_set_out_buf(z_stream *strm, void *buf, unsigned int len) {
  strm->next_out  = (Bytef*)buf;
  strm->avail_out = len;
}

unsigned int zstream_avail_in(z_stream *strm) {
  return strm->avail_in;
}

unsigned int zstream_avail_out(z_stream *strm) {
  return strm->avail_out;
}

int zstream_inflate_init(z_stream *strm, int windowBits) {
  strm->zalloc   = Z_NULL;
  strm->zfree    = Z_NULL;
  strm->opaque   = Z_NULL;
  strm->avail_in = 0;
  strm->next_in  = Z_NULL;
  return inflateInit2(strm, windowBits);
}

int zstream_inflate(z_stream *strm, int flush) {
  return inflate(strm, flush);
}

void zstream_inflate_end(z_stream *strm) {
  inflateEnd(strm);
}

z_stream* zstream_alloc() {
  return calloc(1, sizeof(z_stream));
}

void zstream_free(z_stream *strm) {
  free(strm);
}
